<?php
/**
 * Created by PhpStorm.
 * User: frederic
 * Date: 23/08/17
 * Time: 14:38
 */

namespace ByDedi\MediaBundle\Controller;

use ByDedi\AdminBundle\Controller\CRUDController;
use ByDedi\MediaBundle\Entity\Image;
use Symfony\Component\Form\Extension\Core\Type\FileType;
use Symfony\Component\Form\Extension\Core\Type\SubmitType;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\Validator\Constraints\All;

class ImageController extends CRUDController
{

    /**
     * @return JsonResponse|\Symfony\Component\HttpFoundation\Response
     */
    public function uploadAction() {
        $request = $this->getRequest();

        $form = $this
            ->createFormBuilder(new Image(), [
                'method' => 'post',
                'attr' => ['data-upload-ajax' => true],
                'action' => $request->server->get('REQUEST_URI')
            ])
            ->add('pathFile', FileType::class, [
                'required' => true,
                'label' => 'Image',
                'multiple' => true,
                'constraints' => array(
                    new All(array(
                            'constraints' => new \Symfony\Component\Validator\Constraints\Image()
                        )
                    )
                )
            ])
            ->add('submit', SubmitType::class, [
                'label' => 'Uploader',
                'attr' => [
                    'class' => 'btn btnLv1'
                ]
            ])
            ->getForm();

        $form->handleRequest($request);


        $response = $this->render('MediaBundle:Image/Form:upload.html.twig',[
            'form' => $form->createView()
        ]);


        if ($form->isSubmitted()) {
            $json = ['success' => false, 'html' => null];
            if ($form->isValid()) {
                $image = $form->getData();
                $files = $image->getPathFile();
                $em = $this->getDoctrine()->getManager();
                foreach ($files as $file) {
                    $image = new Image;
                    $image->setPathFile($file);
                    $em->persist($image);
                    $em->flush();
                }

                $json['success'] = true;
                $json['html'] = 'Vos fichiers ont bien été envoyés';
            } else {
                $json['html'] = $this->renderView('MediaBundle:Image/Form:upload.html.twig',[
                    'form' => $form->createView()
                ]);
            }
            $response = new JsonResponse($json);
        }


        return $response;
    }
}